﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.ComponentModel;

namespace XamGridHierarchicalDT
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public DataSet dsOld { get; set; }
        public DataSet dsNew { get; set; }


        public MainWindow()
        {
            InitializeComponent();
            dsOld = GenerateData();
            dsNew = GenerateData1();

            xamGrid1.ItemsSource = dsOld.Tables[0].DefaultView;
        }

        private DataSet GenerateData()
        {
            var data = new DataSet("SimpleData");
        //   data.EnforceConstraints = false;

            DataTable parent = new DataTable("Parent");

            parent.Columns.Add("column1", typeof(int));
            parent.Columns.Add("column2", typeof(int));
            parent.Columns.Add("column3", typeof(int));

            parent.PrimaryKey = new[] { parent.Columns[0] };

            DataTable children = new DataTable("Children");

            children.Columns.Add("column1", typeof(int));
            children.Columns.Add("column4", typeof(int));
            children.Columns.Add("column5", typeof(int));;

          //  children.PrimaryKey = new[] { children.Columns[0] };

            data.Tables.Add(parent);
            data.Tables.Add(children);


            data.Relations.Add("Parent_Child", parent.Columns[0], children.Columns[0], false);
            Random r = new Random();
            for (int i = 1; i < 4; i++)
            {

                data.Tables["Parent"].Rows.Add(new object[] { i, r.Next(100), r.Next(100) });
                for (int j = 0; j < 5; j++)
                {
                    data.Tables["Children"].Rows.Add(new object[] {i, r.Next(100), r.Next(100) });
                }
            }

            data.AcceptChanges();

            return data;
        }

        private DataSet GenerateData1()
        {
            var data = new DataSet("SimpleData");
            //   data.EnforceConstraints = false;

            DataTable parent = new DataTable("Parent");

            parent.Columns.Add("column1", typeof(int));
            parent.Columns.Add("column7", typeof(int));
            parent.Columns.Add("column8", typeof(int));

            parent.PrimaryKey = new[] { parent.Columns[0] };

            DataTable children = new DataTable("Children");

            children.Columns.Add("column1", typeof(int));
            children.Columns.Add("column9", typeof(int));
            children.Columns.Add("column10", typeof(int)); ;

            //  children.PrimaryKey = new[] { children.Columns[0] };

            data.Tables.Add(parent);
            data.Tables.Add(children);


            data.Relations.Add("Parent_Child", parent.Columns[0], children.Columns[0], false);
            Random r = new Random();
            for (int i = 1; i < 4; i++)
            {

                data.Tables["Parent"].Rows.Add(new object[] { i, r.Next(100), r.Next(100) });
                for (int j = 0; j < 5; j++)
                {
                    data.Tables["Children"].Rows.Add(new object[] { i, r.Next(100), r.Next(100) });
                }
            }

            data.AcceptChanges();

            return data;
        }


        private void button1_Click(object sender, RoutedEventArgs e)
        {
            dsOld = dsNew;
            xamGrid1.ItemsSource = null;
            xamGrid1.ItemsSource = dsOld.Tables[0].DefaultView;
        }
    }
}
